Kea: isc::hooks::HooksLibrariesParser Class Reference

| Kea 2.2.0

Public Member Functions | List of all members
isc::hooks::HooksLibrariesParser Class Reference

Parser for hooks library list. More...

`#include <hooks_parser.h>`

Inheritance diagram for isc::hooks::HooksLibrariesParser:
[legend]

## Public Member Functions
void | parse (HooksConfig &libraries, isc::data::ConstElementPtr value)
| Parses parameters value. More...
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t. More...
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t. More...
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value. More...
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type. More...
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present. More...
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child. More...
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope. More...
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope. More...
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope. More...
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range. More...
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element. More...
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope. More...
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values. More...
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list. More...
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type , target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope. More...
template<typename int_type >
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope. More...

## Detailed Description

Parser for hooks library list.

This parser handles the list of hooks libraries. This is an optional list, which may be empty, and is encapsulated into a HooksConfig object.

Definition at line 21 of file hooks_parser.h.

## Member Function Documentation

## ◆ parse()

void isc::hooks::HooksLibrariesParser::parse | ( | HooksConfig & | libraries,
|  | isc::data::ConstElementPtr | value
| ) |  |

Parses parameters value.

Parses configuration entry (list of parameters) and adds each element to the hooks libraries list. The method also checks whether the list of libraries is the same as that already loaded. If not, it checks each of the libraries in the list for validity (they exist and have a "version" function that returns the correct value).

The syntax for specifying hooks libraries allow for library-specific parameters to be specified along with the library, e.g.

"hooks-libraries": [
{
"library": "hook-lib-1.so",
"parameters": {
"alpha": "a string",
"beta": 42
}
},
:
]

The parsing code only checks that:

1. Each element in the hooks-libraries list is a map
2. The map contains an element "library" whose value is a not blank string
3. That there is an optional 'parameters' element.
4. That there are no other element.

This method stores parsed libraries in libraries.

Parameters

  libraries | parsed libraries information will be stored here
  value | pointer to the content to be parsed

Definition at line 28 of file hooks_parser.cc.

References isc::hooks::HooksConfig::add(), isc::hooks::HooksConfig::clear(), isc_throw, and isc::util::str::trim().

Referenced by isc::dhcp::configureDhcp4Server(), isc::dhcp::configureDhcp6Server(), isc::agent::AgentSimpleParser::parse(), isc::d2::D2SimpleParser::parse(), and isc::netconf::NetconfSimpleParser::parse().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- hooks_parser.h
- hooks_parser.cc